#include "BackgroundRemoval.hpp"
#include "Scanner.hpp"
#include "Lut.hpp"
#include <ES2Command/ES2CommandAPI.h>


namespace epsonscan {

void BackgroundRemoval::SetValue(const SDIInt& intVal)
{
	current_ = intVal;
}	
void BackgroundRemoval::Reset()
{
	current_  = kSDIBackgroundRemovalNone;
}

void BackgroundRemoval::GetValue(SDIInt& intVal)
{
	intVal = current_;
}

void BackgroundRemoval::GetCapability(SDICapability &capability)
{
	SetDefaultListCapability(capability);

	capability.supportLevel = kSDISupportLevelNone;

	if (Lut::isFitPluginAvailable())
	{
		ESIndexSet availableColorTypes;

		if (GetValueInt(kSDIColorTypeKey) != kSDIColorTypeMono1)
		{
			// Avilable values
			AddList(capability, kSDIBackgroundRemovalNone);
			AddList(capability, kSDIBackgroundRemovalNormal);
			AddList(capability, kSDIBackgroundRemovalHigh);
			capability.supportLevel = kSDISupportLevelAvailable;
		}else
		{
			capability.supportLevel = kSDISupportLevelUnavailable;
		}	

		// All values		
		AddAllList(capability, kSDIBackgroundRemovalNone);
		AddAllList(capability, kSDIBackgroundRemovalNormal);
		AddAllList(capability, kSDIBackgroundRemovalHigh);	
	}


}

ESDictionary BackgroundRemoval::GetEngineKeyValues()
{
	auto dict =  ESDictionary();

	return dict;
}
	
}//namespace epsonscan
