#include "Brightness.hpp"
#include "Scanner.hpp"
#include <ES2Command/ES2CommandAPI.h>



namespace epsonscan {

void Brightness::SetValue(const SDIInt& intVal)
{
	current_ = intVal;
}	
void Brightness::Reset()
{
	current_  = 0;
}

void Brightness::GetValue(SDIInt& intVal)
{
	intVal = current_;
}

void Brightness::GetCapability(SDICapability &capability)
{
	SetDefaultRangeCapability(capability);
 
	capability.supportLevel= kSDISupportLevelAvailable;


	if (GetValueInt(kSDIColorTypeKey) == kSDIColorTypeMono1)
	{
		capability.minValue = 0;
		capability.maxValue = 0;
		capability.supportLevel= kSDISupportLevelUnavailable;
	}else
	{
		capability.minValue = 0;
		capability.maxValue = 100;
		capability.supportLevel= kSDISupportLevelAvailable;
	}



	capability.allMinValue = 0;
	capability.allMaxValue = 100;
}

ESDictionary Brightness::GetEngineKeyValues()
{
	auto dict =  ESDictionary();
	return dict;
}
	
}//namespace epsonscan
