#include "Key.hpp"
#include "EpsonScan2.h"
#include "ESImageInfo.h"

namespace epsonscan {

	class ColorType : public Key<SDIInt> 
	{
		public:

		explicit ColorType(IKeyDataProvider* dataProvider) : Key<SDIInt>(dataProvider) 
		{

		}

		std::string GetName() const override 
		{;
			return std::string(kSDIColorTypeKey);
		}

		void SetValue(const SDIInt& intVal) override;
		void GetValue(SDIInt& outIntVal) override;
		void GetCapability(SDICapability &capability) override;

		void Reset() override;

		ESNumber GetColorType();
		ESDictionary GetEngineKeyValues() override;

		bool IsHardawaDropout();
		bool IsSoftwareDropout();

		private:
			void GetGammaTable(ESGammaTable& outGammaTable);
	};

}//namespace epsonscan
